#### 成本优化最佳实践

因为Lambda的费用是基于函数执行时间和分配的资源，所以优化成本的重点是优化这两个维度。

##### 合理精简
正如在高效性能中所提到的，假设给函数分配最少的资源将提供最小的成本是一种反面模式。如果函数被分配资源太少，与被分配更多资源以迅速执行完相比，由于更长的执行时间，你可能会支付的更多。

有关更多细节，请参见选择最佳内存大小一节。

##### 分布式和异步架构

你不需要通过一系列阻塞/同步API请求和响应来实现所有用例。如果你能够将应用设计为异步的，那么你可能会发现架构中每个解耦的组件执行其工作所需的计算时间比紧密耦合的组件要少，后者花费CPU周期等待对同步请求的响应。许多Lambda事件源非常适合分布式系统，可以使用它们以更经济的方式集成模块化和解耦的函数。

##### 批处理大小
一些Lambda事件源允许你为每次函数调用(例如，Kinesis和DynamoDB)上交付的记录数量定义批处理大小。你应该测试以找到每个批大小的最佳记录数，以便将每个事件源的轮询频率调优为函数完成任务的速度。

##### 事件源选择

可以与Lambda集成的事件源的多样性意味着你通常有多种可用的解决方案选项来满足需求。根据用例和需求(请求的规模、数据量、所需的延迟等等)，围绕Lambda函数并选择AWS服务作为组件，基于此的架构总成本可能存在不小的差异。